%{?!_without_python2:%global with_python2 1}
%{?!_without_python3:%global with_python3 0%{?_with_python3:1} || !0%{?rhel} || 0%{?rhel} >= 7}

%global srcname wstool

Name:           python-%{srcname}
Version:        0.1.17
Release:        1%{?dist}
Summary:        Tool for managing a workspace of multiple heterogeneous SCM repositories

License:        BSD
URL:            http://www.ros.org/wiki/%{srcname}
Source0:        https://github.com/vcstools/%{srcname}/archive/%{version}/%{srcname}-%{version}.tar.gz

# Patch to remove a duplicate installed file.  Not submitted upstream
Patch0:         %{srcname}-0.1.9-fedora.patch
# Merged upstream in vcstools/wstool#134
Patch1:         %{srcname}-0.1.17-yaml-safe-load.patch
# Merged upstream in vcstools/wstool#133
Patch2:         %{srcname}-0.1.17-yaml-flow-style.patch

BuildArch:      noarch

BuildRequires:  bzr
BuildRequires:  git
BuildRequires:  mercurial
BuildRequires:  python2-sphinx
BuildRequires:  subversion

%global _description\
wstool provides commands to manage several local SCM repositories (supports\
git, mercurial, subversion, bazaar) based on a single workspace definition file\
(.rosinstall).\
\
wstool replaces the rosws tool for catkin workspaces. As catkin workspaces\
create their own setup file and environment, wstool is reduced to version\
control functions only. So wstool does not have a "regenerate" command, and\
does not allow adding non-version controlled elements to workspaces. In all\
other respects, it behaves the same as rosws.

%description %_description


%if 0%{?with_python2}
%package -n python2-%{srcname}
Summary:        %{summary}
BuildRequires:  python2-dateutil
BuildRequires:  python2-devel
BuildRequires:  python2-mock
BuildRequires:  python2-pyyaml
BuildRequires:  python2-nose
BuildRequires:  python2-setuptools
BuildRequires:  python2-vcstools >= 0.1.38
Requires:       bzr
Requires:       git
Requires:       mercurial
Requires:       subversion
%{?python_provide:%python_provide python2-%{srcname}}

%if %{undefined __pythondist_requires}
Requires:       python2-dateutil
Requires:       python2-pyyaml
Requires:       python2-vcstools >= 0.1.38
%endif # __pythondist_requires

%description -n python2-%{srcname} %_description
%endif # with_python2


%if 0%{?with_python3}
%package -n python%{python3_pkgversion}-%{srcname}
Summary:        %{summary}
BuildRequires:  python%{python3_pkgversion}-dateutil
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-mock
BuildRequires:  python%{python3_pkgversion}-nose
BuildRequires:  python%{python3_pkgversion}-PyYAML
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  python%{python3_pkgversion}-vcstools >= 0.1.38
Requires:       bzr
Requires:       git
Requires:       mercurial
Requires:       subversion
%{?python_provide:%python_provide python%{python3_pkgversion}-%{srcname}}

%if %{undefined __pythondist_requires}
Requires:       python%{python3_pkgversion}-dateutil
Requires:       python%{python3_pkgversion}-PyYAML
Requires:       python%{python3_pkgversion}-vcstools >= 0.1.38
%endif # __pythondist_requires

%description -n python%{python3_pkgversion}-%{srcname} %_description
%endif # with_python3


%prep
%autosetup -p1 -n %{srcname}-%{version}


%build
%if 0%{?with_python2}
%py2_build
%endif # with_python2

%if 0%{?with_python3}
%py3_build
mv -v build/scripts-%{python3_version}/%{srcname} build/scripts-%{python3_version}/python3-%{srcname}
%endif # with_python3


%install
%if 0%{?with_python2}
%py2_install
%endif # with_python2

%if 0%{?with_python3}
%py3_install
%endif # with_python3


%check
export BZR_EMAIL="Foo Bar <foo@example.com>"
export GIT_AUTHOR_EMAIL="foo@example.com"
export GIT_AUTHOR_NAME="Foo Bar"
export GIT_COMMITTER_EMAIL="foo@example.com"
export GIT_COMMITTER_NAME="Foo Bar"

%if 0%{?with_python2}
%{__python2} -m nose test
%endif # with_python2

%if 0%{?with_python3}
%{__python3} -m nose test
%endif # with_python3


%if 0%{?with_python2}
%files -n python2-%{srcname}
%license LICENSE
%doc README.rst doc/changelog.rst
%{python2_sitelib}/%{srcname}/
%{python2_sitelib}/%{srcname}-%{version}-py%{python2_version}.egg-info/
%{_bindir}/%{srcname}
%{_mandir}/man1/%{srcname}.1.gz
# bash completion
%config(noreplace) %{_sysconfdir}/bash_completion.d/%{srcname}-completion.bash
# zsh completion
%dir %{_datadir}/zsh/
%dir %{_datadir}/zsh/site-functions/
%{_datadir}/zsh/site-functions/_wstool
%endif # with_python2

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-%{srcname}
%license LICENSE
%doc README.rst doc/changelog.rst
%{python3_sitelib}/%{srcname}/
%{python3_sitelib}/%{srcname}-%{version}-py%{python3_version}.egg-info/
%{_bindir}/python3-%{srcname}
%endif # with_python3


%changelog
* Tue Jul 16 2019 Scott K Logan <logans@cottsay.net> - 0.1.17-1
- Add upstream patches for newer PyYAML compatibility (rhbz#1712544)
- Drop test coverage
- Handle automatic dependency generation (f30+)
- Switch from {commit} to {version} for source archive
- Align spec with python templates
- Update to latest release (rhbz#1533303)

* Tue Oct 20 2015 Rich Mattes <richmattes@gmail.com> - 0.1.12-1
- Update to release 0.1.12 (rhbz#1271029)

* Wed Sep 16 2015 Rich Mattes <richmattes@gmail.com> - 0.1.10-1
- Update to release 0.1.10 (rhbz#1261684)

* Sun Sep 13 2015 Rich Mattes <richmattes@gmail.com> - 0.1.9-1
- Update to release 0.1.9 (rhbz#1261684)

* Wed Mar 04 2015 Rich Mattes <richmattes@gmail.com> - 0.1.6-1
- Update to release 0.1.6 (rhbz#1195537)

* Sun Dec 14 2014 Scott K Logan <logans@cottsay.net> - 0.1.5-1
- Update to 0.1.5
- Update to python packaging guidelines
- Add check section

* Sun Jan 12 2014 Rich Mattes <richmattes@gmail.com> - 0.1.1-1
- Update to 0.1.1

* Mon Aug 26 2013 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.0.3-1
- Rename python3 bin script

* Sun Aug 25 2013 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.0.3-1
- Update source to github source
- Add py3 support

* Sat Mar 16 2013 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.0.3-1
- Initial rpmbuild

